wit_bindgen::generate!({
    world: "host",
    generate_all,
    path: "../wit",
});

struct MyStruct;

impl exports::wasi::cli::run::Guest for MyStruct {
    fn run() -> Result<(),()> {

        let default_rec = Rec {
            x: 0, // can be anything
            f2: "".to_string(), // ^
        };

        let x4: u8 = 1; // this value should be printed, but isn't (can be anything)
        
        let special_rec = Rec {
            x: -1, // this field is magically converted to typeof(x4) and printed instead
            f2: "".to_string(), // can be anything
        };
        
        println!("Sending: {x4}");

        foo(
            &default_rec, 
            &default_rec, 
            x4, // prints x4
            &special_rec
        );
        
        Ok(())
    }
}

export!(MyStruct);