#!/bin/bash

cargo build --manifest-path guest/Cargo.toml --target wasm32-wasip2
cargo build --manifest-path host/Cargo.toml --target wasm32-wasip2

wac plug --plug guest/target/wasm32-wasip2/debug/guest.wasm host/target/wasm32-wasip2/debug/host.wasm -o exe.wasm

wasmtime exe.wasm